// IDELAY̒xʂωĂƓǂ߂邩𔻒
// idelay_controller.v

// pscount ʑVtgp̃JE^
// ps1 - Ƀf[^󂩂͂߂̈ʑVtgJE^̒l, ps2 - f[^󂯂ĂāAf[^̈ʑVtgJE^̒l
// variable_idelay_state̎ɒx𑝂₵čsBŏ͎󂩂f[^͌Ă邪AƂŐf[^ɂȂ͂łB̒xlps1Ƀ[hB
// ̌Axl𑝂₵ĂƁA܂f[^悤ɂȂ邩ȂB̒lps2ƂB
// ps1ps2̒Ԃ̒xlԗǂxlƂȂBps3ƂB
// f[^Ȃps2̒lƂ肦B̏ꍇps20NAꂽ܂܁B̏ꍇps1ƍőxl̒Ԃ̒xlps3ƂB
// adjusted_idelay_stateps3̒l܂Œxl߂ƂBőxl1xCNgƒxl0NÂŁAps3̒xl܂Œxi߂΂悢B
	
// 2008/04/25

`default_nettype none
`timescale 1ns / 1ps

module idelay_controller(
	input wire clk,
	input wire reset,
	input wire variable_idelay_state, // IDELAY̒lςď񂾃f[^[hł邩ǂ𒲂ׂXe[g
	input wire adjusted_idelay_state, // variable_idelay_stateŒׂlɂāA傤Ǘǂxlɐݒ肷Xe[g
	input wire read_data_is_right, // [hf[^,b`o
	input wire rddata_is_right_timing, // read_data_is_righto͂^C~O
	output wire variable_idelay_end, // variable_idelay_stateIBxlőɂȂB
	output wire adjusted_idelay_end, // ps3̒xl܂Œxli߂
	output wire var_idelay_read, // xlςāAxl肵̂READR}h𔭍s
	output wire idelay_inc, // idelay_ce=1̎idelay_inc=1ŒxlA0Ō
	output reg idelay_ce // idelay_ce=1̎ɒxl
);
	reg [5:0] ps1, ps2, ps3;
	reg [5:0] idelay_cnt;
	reg rd_was_right; // [hf[^x͐lɂȂƂ
	reg ps1_stop_flag; // ps1̃JEgXgbvBȃf[^ǂ߂
	reg [2:0] var_cnt1; // idelay_ceoĂ6JEg
	reg [2:0] var_cnt2; // READR}hoĂ6JEg
	
	parameter	idle_var_idelay		= 8'b00000001,
				variable_idelay		= 8'b00000010,
				wait_var_1			= 8'b00000100,
				wait_var_2			= 8'b00001000,
				var_idelay_read_st	= 8'b00010000,
				wait_var_3			= 8'b00100000,
				wait_var_4			= 8'b01000000,
				adjusted_idelay		= 8'b10000000;
	
	reg [7:0] ns, cs;
	
	assign idelay_inc = 1'b1; // Ƃ肠CNĝ
	
	always @(posedge clk) begin // ps1
		if (reset) begin
			ps1 <= 0;
			ps1_stop_flag <= 1'b0;
		end else begin
			if (variable_idelay_state && rddata_is_right_timing) begin // IDELAYςă[hf[^ĂԂɃJEg
				if (read_data_is_right==1'b0 && ps1_stop_flag==1'b0) // ŏ̃JEgŃf[^
					ps1 <= ps1 + 1;
				else if (read_data_is_right && ps1_stop_flag==1'b0) // f[^ŏɎ󂯂ꂽ
					ps1_stop_flag <= 1'b1;
			end
		end
	end
	
	always @(posedge clk) begin // ps2
		if (reset) begin
			ps2 <= 0;
			rd_was_right <= 1'b0;
		end else begin
			if (variable_idelay_state && rddata_is_right_timing) begin // IDELAY̒lςď񂾃f[^[hł邩ǂ𒲂ׂXe[g
				if (read_data_is_right && rddata_is_right_timing) // [hf[^l
					rd_was_right <= 1'b1;
				
				if (rd_was_right==1'b0) // [hf[^lɂȂO͕ȂJEg
					ps2 <= ps2 + 1;
				else if (rd_was_right && read_data_is_right && rddata_is_right_timing) // [hf[^lł
					ps2 <= ps2 + 1;
			end
		end
	end
	
	always @(posedge clk) begin // ps3
		if (reset)
			ps3 <= 0;
		else
			ps3 <= ps1 + ((ps2 - ps1)>>1); // ps1 + (ps2-ps1)/2
	end
	
	always @(posedge clk) begin // IDELAY̒lJEg
		if (reset)
			idelay_cnt <= 0;
		else begin
			if (cs==variable_idelay || cs==adjusted_idelay)
				idelay_cnt <= idelay_cnt + 1;
		end
	end
	
	always @(posedge clk) begin
		if (reset)
			cs <= idle_var_idelay;
		else
			cs <= ns;
	end
	
	always @* begin
		case (cs)
			idle_var_idelay : begin
				idelay_ce <= 1'b0;
				if (variable_idelay_state)
					ns <= variable_idelay;
				else if (adjusted_idelay_state)
					ns <= adjusted_idelay;
				else
					ns <= idle_var_idelay;
			end
			variable_idelay : begin// IDELAY̒l1
				idelay_ce <= 1'b1;
				ns <= wait_var_1;
			end
			wait_var_1 : begin
				idelay_ce <= 1'b0;
				ns <= wait_var_2;
			end
			wait_var_2 : begin
				if (var_cnt1==0)
					ns <= var_idelay_read_st;
				else
					ns <= wait_var_2;
				idelay_ce <= 1'b0;
			end
			var_idelay_read_st : begin // IDELAY̒lm
				idelay_ce <= 1'b0;
				ns <= wait_var_3;
			end
			wait_var_3 : begin
				idelay_ce <= 1'b0;
				ns <= wait_var_4;
			end
			wait_var_4 : begin
				idelay_ce <= 1'b0;
				if (var_cnt2==0)
					ns <= idle_var_idelay;
				else
					ns <= wait_var_4;
			end
			
			adjusted_idelay : begin // ps3̒lIDELAYZbg
				idelay_ce <= 1'b1;
				if (idelay_cnt+1==ps3)
					ns <= idle_var_idelay;
				else
					ns <= adjusted_idelay;
			end
		endcase
	end
	assign var_idelay_read = (cs==var_idelay_read_st) ? 1'b1 : 1'b0; // IDELAY̒lm肵READR}h𔭍s
	assign variable_idelay_end = (cs==wait_var_4 && idelay_cnt==6'b111111) ? 1'b1 : 1'b0; // idelay_cntI[1̎IDELAYωREADl̂͏I
	assign adjusted_idelay_end = (cs==adjusted_idelay && idelay_cnt+1==ps3) ? 1'b1 : 1'b0;
	
	always @(posedge clk) begin
		if (reset)
			var_cnt1 <= 0;
		else
			if (cs==wait_var_1)
				var_cnt1 <= 4'd6;
			else if (cs==wait_var_2 && var_cnt1!=0)
				var_cnt1 <= var_cnt1 - 1;
	end
	
	always @(posedge clk) begin
		if (reset)
			var_cnt2 <= 0;
		else
			if (cs==wait_var_3)
				var_cnt2 <= 4'd6;
			else if (cs==wait_var_4 && var_cnt2!=0)
				var_cnt2 <= var_cnt2 - 1;
	end
	
// synthesis translate_off
	reg [20*8:1] VAR_IDELAY_STATE;
	
	always @(cs) begin
		case (cs)
			idle_var_idelay:	VAR_IDELAY_STATE <= "IDLE_VAR_IDELAY";
			variable_idelay:	VAR_IDELAY_STATE <= "VARIABLE_IDELAY";
			wait_var_1:			VAR_IDELAY_STATE <= "WAIT_VAR_1";
			wait_var_2:			VAR_IDELAY_STATE <= "WAIT_VAR_2";
			var_idelay_read_st:	VAR_IDELAY_STATE <= "VAR_IDELAY_READ_ST";
			wait_var_3:			VAR_IDELAY_STATE <= "WAIT_VAR_3";
			wait_var_4:			VAR_IDELAY_STATE <= "WAIT_VAR_4";
			default:	VAR_IDELAY_STATE <= "ADJUSTED_IDELAY";
		endcase
	end
// synthesis translate_on

endmodule
	
	
