// Frequncy Divider for Dynamic Lighting
// 1KHz clock
// }X^[NbN1KHzdisp_enaɕ܂B
// NbNgclk_frequencyKHzPʂŐݒ肵ĂBdefault50MHzłB
// lcnt16rbgɂȂĂ̂ŁAclk_frequency65536ȏ̏ꍇ̓rbg𑝂₵ĂB
// sync resetɕύX

`default_nettype none
`timescale 1ns / 1ps

module FreqDiv(clk, reset, disp_ena);
	input clk, reset;
	output disp_ena;
	wire clk, reset;
	wire disp_ena;
	
	reg [20:0] lcnt;
	
	parameter clk_frequency = 200000;
	
	always @(posedge clk) begin
		if (reset)
			lcnt <= 0;
		else if (lcnt==clk_frequency)
			lcnt <= 0;
		else
			lcnt <= lcnt + 1;
	end
	
	assign disp_ena = (lcnt==clk_frequency);
endmodule
